unit Fmatrix;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids;

type
  TFrmInvert = class(TForm)
    SGMat: TStringGrid;
    ButDone: TButton;
    ButInvert: TButton;
    ButClear: TButton;
    ButFill: TButton;
    procedure FormActivate(Sender: TObject);
    procedure ButDoneClick(Sender: TObject);
    procedure ButInvertClick(Sender: TObject);
    procedure SGMatSetEditText(Sender: TObject; ACol, ARow: Longint;
      const Value: String);
    procedure ButFillClick(Sender: TObject);
    procedure ButClearClick(Sender: TObject);
  private
    procedure LoadStringGrid;
  public
    { Public declarations }
  end;

var
  FrmInvert: TFrmInvert;

implementation

{$R *.DFM}

uses
  matrix;

const
  MatSize = 6;

var
  Mat1: TMatrix;

(*******************************************************************)
procedure TFrmInvert.LoadStringGrid;
(*******************************************************************)

var
  i,j  : integer;
  astr : string;

begin
for i:=1 to MatSize do
  for j:=1 to MatSize do
    begin
    str (Mat1.Elem[i,j]:1:2, astr);
    SGMat.Cells[i-1,j-1] := astr;
    end;
end;

(*******************************************************************)
procedure TFrmInvert.FormActivate(Sender: TObject);
(*******************************************************************)

var
  i,j    : integer;
  AuxVal : double;
  astr   : string;

begin
SGMat.DefaultColWidth := 64;
Mat1 := TMatrix.Create (MatSize,MatSize);
for i:=1 to MatSize do
  for j:=1 to MatSize do
    begin
    AuxVal := 10*random - 5;
    str (AuxVal:1:2, astr);
    SGMat.Cells[i-1,j-1] := astr;
    Mat1.Elem[i,j] := AuxVal;
    end;
end;

(*******************************************************************)
procedure TFrmInvert.ButDoneClick(Sender: TObject);
(*******************************************************************)

begin
Mat1.Free;
close;
end;

(*******************************************************************)
procedure TFrmInvert.ButInvertClick(Sender: TObject);
(*******************************************************************)

begin
if Mat1.Invert
  then LoadStringGrid
  else begin
       SHowMessagePos ('ERROR during matrix inversion: the original values are lost and the matrix is cleared',
                       FrmInvert.Left+10,FrmInvert.Top+10);
       Mat1.Fill (0.0);
       LoadStringGrid;
       end;
end;

(*******************************************************************)
procedure TFrmInvert.SGMatSetEditText(Sender: TObject; ACol, ARow: Longint;
  const Value: String);
(*******************************************************************)

var
  AuxStr : string;
  ddummy : double;
  status : integer;

begin
AuxStr := SGMat.Cells[ACol,ARow];
val (AuxStr, ddummy, status);
Mat1.Elem[ACol+1,ARow+1] := ddummy;
end;

(*******************************************************************)
procedure TFrmInvert.ButFillClick(Sender: TObject);
(*******************************************************************)

var
  i,j : integer;

begin
for i:=1 to MatSize do
  for j:=1 to MatSize do
    Mat1.Elem[i,j] := 10*random - 5;
LoadStringGrid;
end;

(*******************************************************************)
procedure TFrmInvert.ButClearClick(Sender: TObject);
(*******************************************************************)

begin
Mat1.Fill(0.0);
LoadStringGrid;
end;

end.
